/*
 * main.cpp
 *
 *  Created on: Feb 26, 2024
 *      Author: yasmine
 */
#include <mviz/mviz.h>
#include <publisher.h>
#include "can/SignalsToSWCs_Type.h"
#include "sub/SubWrapperHelper.h"
#include "can_msg_node/executable.h"
#include "impl_type_can2swc.h"
#include "VIZ_SubDataWrapper.h"
using namespace huawei::ap::sample::proxy;

//SubWrappers
GENERATE_SUB_WRAPPER(VIZ_Required, VIZ_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "4", 10);

bool connect_mviz()
{
	return mdc::visual::Connect();
}

//bool create_node(mviz::NodeHandle &nodeHandle, mviz::Publisher &pub, mviz::Subscriber &sub)
//{
//
//}


int main()
{
	ara::log::InitLogging("DPC", "EM_TEST", ara::log::LogLevel::kVerbose, (ara::log::LogMode::kConsole | ara::log::LogMode::kRemote));

	ara::log::Logger &mainLog { ara::log::CreateLogger("main", "em sample context", ara::log::LogLevel::kVerbose) };

	mainLog.LogInfo() << "Let's produce some em data...";

	VIZ_Required _viz_Required("visualization/visualization/VisCAN2SWCRPort",mainLog);


	mviz::Publisher pub;
	connect_mviz();
	mviz::NodeHandle nodeHandle;
	pub = nodeHandle.Advertise<can::SignalsToSWCs_Type>("can_data");
	_viz_Required.s.set_publisher(&pub);
	_viz_Required.Init();
	while(1)
	{
	//sub = nodeHandle.Subscribe("ros_data", &UserDefinedMsgs::Callback, this);
		std::this_thread::sleep_for(std::chrono::milliseconds(300));
	}
	_viz_Required.Destroy();

	return 0;
}



